﻿Imports System.Drawing.Imaging
Imports System.Drawing.Drawing2D

Public Class Form1

    'For the Normal function, stores the original width of image 
    Private w As Integer

    'For the Normal function, stores the original height of image
    Private h As Integer

    'For Zoom in and zoom out
    Private zoom As Integer
    Private Const MAX As Integer = 3
    Private Const MIN As Integer = 1

    'Two possible to zoom in or zoom out the image:
    ' - interpolation with real image
    ' - only zoom in/out the picturebox (now)

    'This function makes the picture larger or smaller
    Public Function PictureBoxZoom(ByVal img As Image, ByVal size As Double) As Image
        Dim bm As Bitmap = New Bitmap(img, Convert.ToInt32(img.Width * size), Convert.ToInt32(img.Height * size))
        Dim grap As Graphics = Graphics.FromImage(bm)
        grap.InterpolationMode = InterpolationMode.NearestNeighbor
        Return bm
    End Function

    Private Sub ZoomIn()
        If Not PictureBox1.Image Is Nothing Then
            If zoom <= MAX Then
                Try
                    zoom = zoom + 1
                    'Interpolation
                    'Dim imgOriginal As Image = PictureBox1.Image
                    'PictureBox1.Image = PictureBoxZoom(imgOriginal, 1.2)
                    'PictureBox1.Width = PictureBox1.Image.Width
                    'PictureBox1.Height = PictureBox1.Image.Height

                    'PictureBox 
                    PictureBox1.Width = PictureBox1.Width * 2
                    PictureBox1.Height = PictureBox1.Height * 2
                    PictureBox1.Refresh()

                Catch ex As Exception
                    MessageBox.Show("You reached the maximum size", "Error", MessageBoxButtons.OK, MessageBoxIcon.Stop)
                End Try
            End If
        End If
    End Sub

    Private Sub ZoomOut()
        If Not PictureBox1.Image Is Nothing Then
            If MIN <= zoom Then
                Try
                    zoom = zoom - 1
                    'Interpolation
                    'Dim imgOriginal As Image = PictureBox1.Image
                    'PictureBox1.Image = PictureBoxZoom(imgOriginal, 0.8)
                    'PictureBox1.Width = PictureBox1.Image.Width
                    'PictureBox1.Height = PictureBox1.Image.Height

                    'PictureBox
                    PictureBox1.Width = PictureBox1.Width / 2
                    PictureBox1.Height = PictureBox1.Height / 2
                    PictureBox1.Refresh()
                Catch ex As Exception
                    MessageBox.Show("You reached the minimum size", "Error", MessageBoxButtons.OK, MessageBoxIcon.Stop)
                End Try
            End If
        End If
    End Sub

    'Information in the statuslabel about the size of opened image
    Private Sub statusLabel()
        Try
            ToolStripStatusLabel1.Text = "(" & PictureBox1.Width.ToString & ", " & PictureBox1.Height.ToString & ")"
        Catch ex As Exception
        End Try
    End Sub

    Private Sub OpenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenToolStripMenuItem.Click
        Try
            zoom = 0
            OpenFileDialog1.Filter = "Images|*.GIF;*.TIF;*.JPG"
            OpenFileDialog1.ShowDialog()
            If OpenFileDialog1.FileName = "" Then Exit Sub
            PictureBox1.Image = Image.FromFile(OpenFileDialog1.FileName)
            w = PictureBox1.Image.Width
            h = PictureBox1.Image.Height
            PictureBox1.Width = w
            PictureBox1.Height = h
            'PictureBox1.Width = PictureBox1.Height * PictureBox1.Image.Width / PictureBox1.Image.Height
            statusLabel()
        Catch ex As Exception
        End Try
    End Sub

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        Me.Close()
    End Sub

    Private Sub SaveAsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveAsToolStripMenuItem.Click
        Try
            SaveFileDialog1.Filter = "Jpeg Image|*.jpg|Bitmap Image|*.bmp|Gif Image|*.gif"
            SaveFileDialog1.Title = "Save an Image File"
            If SaveFileDialog1.ShowDialog() = DialogResult.OK Then
                Dim extension As String = SaveFileDialog1.FileName()
                extension = _
                    extension.Substring(extension.LastIndexOf(".") _
                    + 1).ToLower
                Select Case extension
                    Case "bmp"
                        PictureBox1.Image.Save(SaveFileDialog1.FileName, _
                            ImageFormat.Bmp)
                    Case "jpg", "jpeg"
                        PictureBox1.Image.Save(SaveFileDialog1.FileName, _
                            ImageFormat.Jpeg)
                    Case "gif"
                        PictureBox1.Image.Save(SaveFileDialog1.FileName, _
                            ImageFormat.Gif)
                    Case "ico"
                        PictureBox1.Image.Save(SaveFileDialog1.FileName, _
                            ImageFormat.Icon)
                    Case "emf"
                        PictureBox1.Image.Save(SaveFileDialog1.FileName, _
                            ImageFormat.Emf)
                    Case "wmf"
                        PictureBox1.Image.Save(SaveFileDialog1.FileName, _
                            ImageFormat.Wmf)
                    Case "png"
                        PictureBox1.Image.Save(SaveFileDialog1.FileName, _
                            ImageFormat.Png)
                    Case "tif", "tiff"
                        PictureBox1.Image.Save(SaveFileDialog1.FileName, _
                            ImageFormat.Tiff)
                    Case "exif"
                        PictureBox1.Image.Save(SaveFileDialog1.FileName, _
                            ImageFormat.Exif)
                End Select
            End If
        Catch ex As NullReferenceException
            MessageBox.Show("Not opened file!", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
        End Try
    End Sub

    Private Sub RotateLeftToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RotateLeftToolStripMenuItem.Click
        If Not PictureBox1.Image Is Nothing Then
            PictureBox1.Image.RotateFlip(RotateFlipType.Rotate270FlipNone)
            Dim x As Integer = PictureBox1.Width
            PictureBox1.Width = PictureBox1.Height
            PictureBox1.Height = x
            PictureBox1.Refresh()
        End If
        statusLabel()
    End Sub

    Private Sub RotateRightToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RotateRightToolStripMenuItem.Click
        If Not PictureBox1.Image Is Nothing Then
            PictureBox1.Image.RotateFlip(RotateFlipType.Rotate90FlipNone)
            Dim x As Integer = PictureBox1.Width
            PictureBox1.Width = PictureBox1.Height
            PictureBox1.Height = x
            PictureBox1.Refresh()
        End If
        statusLabel()
    End Sub

    Private Sub FlipHorizontalToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FlipHorizontalToolStripMenuItem.Click
        If Not PictureBox1.Image Is Nothing Then
            PictureBox1.Image.RotateFlip(RotateFlipType.RotateNoneFlipX)
            PictureBox1.Refresh()
        End If
        statusLabel()
    End Sub

    Private Sub FlipVerticalToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FlipVerticalToolStripMenuItem.Click
        If Not PictureBox1.Image Is Nothing Then
            PictureBox1.Image.RotateFlip(RotateFlipType.RotateNoneFlipY)
            PictureBox1.Refresh()
        End If
        statusLabel()
    End Sub

    Private Sub NormalToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NormalToolStripMenuItem.Click
        If Not PictureBox1.Image Is Nothing Then
            zoom = 0
            PictureBox1.Width = w
            PictureBox1.Height = h
            PictureBox1.Refresh()
        End If
        statusLabel()
    End Sub

    Private Sub ZoomInToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ZoomInToolStripMenuItem.Click
        ZoomIn()
        statusLabel()
    End Sub

    Private Sub ZoomOutToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ZoomOutToolStripMenuItem.Click
        ZoomOut()
        statusLabel()
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        zoom = 0
    End Sub

    'Handling with mouse to zoom in and zoom out the image
    Private Sub PictureBox1_MouseClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseClick
        Select Case e.Button
            Case Windows.Forms.MouseButtons.Right
                ZoomIn()
            Case Windows.Forms.MouseButtons.Left
                ZoomOut()
        End Select
        statusLabel()
    End Sub

    'Sharpening seems to bring out image detail that was not there before.
    Private Sub SharpenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SharpenToolStripMenuItem.Click
        If Not PictureBox1.Image Is Nothing Then
            Dim bmap As Bitmap = New Bitmap(PictureBox1.Image)
            PictureBox1.Image = bmap
            Dim tempbmp As New Bitmap(PictureBox1.Image)
            Dim DX As Integer = 1
            Dim DY As Integer = 1
            Dim red, green, blue As Integer

            Dim i, j As Integer
            With tempbmp
                For i = DX To .Height - DX - 1
                    For j = DY To .Width - DY - 1
                        red = CInt(.GetPixel(j, i).R) + 0.5 * CInt((.GetPixel(j, i).R) - CInt(.GetPixel(j - DX, i - DY).R))
                        green = CInt(.GetPixel(j, i).G) + 0.7 * CInt((.GetPixel(j, i).G) - CInt(.GetPixel(j - DX, i - DY).G))
                        blue = CInt(.GetPixel(j, i).B) + 0.5 * CInt((.GetPixel(j, i).B - CInt(.GetPixel(j - DX, i - DY).B)))
                        red = Math.Min(Math.Max(red, 0), 255)
                        green = Math.Min(Math.Max(green, 0), 255)
                        blue = Math.Min(Math.Max(blue, 0), 255)
                        bmap.SetPixel(j, i, Color.FromArgb(red, green, blue))
                    Next
                Next
            End With
            statusLabel()
        End If
    End Sub

    'Function of smoothing
    Private Sub SmoothToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SmoothToolStripMenuItem.Click
        If Not PictureBox1.Image Is Nothing Then
            Dim bmap As Bitmap = New Bitmap(PictureBox1.Image)
            PictureBox1.Image = bmap
            Dim tempbmp As New Bitmap(PictureBox1.Image)
            Dim DX As Integer = 1
            Dim DY As Integer = 1
            Dim red, green, blue As Integer

            Dim i, j As Integer
            With tempbmp
                For i = DX To .Height - DX - 1
                    For j = DY To .Width - DY - 1
                        red = CInt((CInt(.GetPixel(j - 1, i - 1).R) + _
                                CInt(.GetPixel(j - 1, i).R) + _
                                CInt(.GetPixel(j - 1, i + 1).R) + _
                                CInt(.GetPixel(j, i - 1).R) + _
                                CInt(.GetPixel(j, i).R) + _
                                CInt(.GetPixel(j, i + 1).R) + _
                                CInt(.GetPixel(j + 1, i - 1).R) + _
                                CInt(.GetPixel(j + 1, i).R) + _
                                CInt(.GetPixel(j + 1, i + 1).R)) / 9)

                        green = CInt((CInt(.GetPixel(j - 1, i - 1).G) + _
                                CInt(.GetPixel(j - 1, i).G) + _
                                CInt(.GetPixel(j - 1, i + 1).G) + _
                                CInt(.GetPixel(j, i - 1).G) + _
                                CInt(.GetPixel(j, i).G) + _
                                CInt(.GetPixel(j, i + 1).G) + _
                                CInt(.GetPixel(j + 1, i - 1).G) + _
                                CInt(.GetPixel(j + 1, i).G) + _
                                CInt(.GetPixel(j + 1, i + 1).G)) / 9)

                        blue = CInt((CInt(.GetPixel(j - 1, i - 1).B) + _
                                CInt(.GetPixel(j - 1, i).B) + _
                                CInt(.GetPixel(j - 1, i + 1).B) + _
                                CInt(.GetPixel(j, i - 1).B) + _
                                CInt(.GetPixel(j, i).B) + _
                                CInt(.GetPixel(j, i + 1).B) + _
                                CInt(.GetPixel(j + 1, i - 1).B) + _
                                CInt(.GetPixel(j + 1, i).B) + _
                                CInt(.GetPixel(j + 1, i + 1).B)) / 9)
                        red = Math.Min(Math.Max(red, 0), 255)
                        green = Math.Min(Math.Max(green, 0), 255)
                        blue = Math.Min(Math.Max(blue, 0), 255)
                        bmap.SetPixel(j, i, Color.FromArgb(red, green, blue))
                    Next
                Next
            End With
            PictureBox1.Refresh()
            statusLabel()
        End If
    End Sub

    Private Sub AboutToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AboutToolStripMenuItem.Click
        MessageBox.Show("Image Processing Program for MMS/JKU/Linz - 22. 06. 2010", "About", MessageBoxButtons.OK, MessageBoxIcon.Information)
    End Sub
End Class
